<template>
  <div>
    <div class="" v-if="!themeColor.Text.includes('playful')">
      <div class="pt-4 px-4 flex overflow-auto hideScrollbar gap-2">
        <template v-for="tab in headerTab" :key="tab">
          <div
            v-if="tab !== 'Game Type' && tab !== 'Provider'"
            @click="onGameTabClicked(tab)"
          >
            <div
              class="py-2 px-4 cursor-pointer whitespace-nowrap border rounded-lg bg-background1"
              :class="{
                'btn-selected bg-primary border-0 --text4': (tabInitial === tab) && !searchModel,
              }"
            >
              <div class="flex items-center">
                <div class="text-xs font-normal --text4 opacity-50" :class="{'opacity' : tabInitial === tab}">
                  {{ $t(tab.replace(' ', '_').toLowerCase()) }}
                </div>
              </div>
            </div>
          </div>
        </template>
        <div
          v-for="gameType in gameTypes"
          :key="gameType"
          @click="onGameTabClicked('Game Type', gameType)"
        >
          <div
            class="py-2 px-4 cursor-pointer whitespace-nowrap border rounded-lg bg-background1"
            :class="{
              'btn-selected bg-primary border-0 --text4': (subTabInitial === gameType) && !searchModel,
            }"
          >
            <div class="flex items-center">
              <div class="text-xs font-normal --text4 opacity-50" :class="{'opacity' : subTabInitial === gameType}">
                {{ $t(gameType.toLowerCase()) }}
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="flex overflow-auto pt-2 px-4 items-center gap-2">
        <template v-for="tab in headerTab" :key="tab">
          <el-select
            class="transition-width duration-500 ease-in-out"
            v-if="tab === 'Provider'"
            v-model="providerModel"
            popper-class="dropdown-width h-[285px]"
            :style="`width: ${!isSeachGameFocus ? '75%' : '25%' };`"
            :placeholder="$t('provider')"
          >
            <template #prefix>
              <img v-if="providerModel" class="z-10 w-6 h-6" :src="getProviderLogo(providerModel)" />
              <img v-else class="z-10 w-6 h-6"
                :src="getAssetImage('assets/theme/common/icon/provider.png')"
              />
            </template>
            <el-option
              v-for="provider in providers"
              :key="provider"
              :class="`${
                (subTabInitial === provider.ProviderName) && !searchModel
                  ? 'border-b selected selected-icon'
                  : 'fc-text pl-2'
              } ${
                provider.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
              }`"
              :value="provider.ProviderName"
              @click="onGameTabClicked(tab, provider.ProviderName)"
            >
              <div class="flex justify-between w-full">
                <div class="flex items-center gap-2">
                  <img class="w-6 h-6" :src="getProviderLogo(provider.ProviderName)" />
                  <div>
                    {{ $t(provider.ProviderName) }}
                  </div>
                  <div
                    v-if="provider.HasNewGame"
                    class="ml-3 px-2 py-0 h-[1rem] rounded-md text-xs bg-orange-500 text-white"
                  >
                    New
                  </div>
                  <div
                    v-if="provider.HasPromoGame"
                    class="ml-3 px-2 py-0 h-[1rem] rounded-md text-xs bg-blue-500 text-white"
                  >
                    Promo
                  </div>
                  <div
                    class="w-[16px] ml-[11px]"
                    :class="
                      subTabInitial === provider.ProviderName
                        ? 'block'
                        : 'hidden'
                    "
                  >
                    <font-awesome-icon icon="circle-check" />
                  </div>
                </div>
              </div>
            </el-option>
          </el-select>
        </template>
        <el-input
          @focus="isSeachGameFocus = true"
          @blur="isSeachGameFocus = false"
          @input="onInputSearch"
          v-model="searchModel"
          class="flex-auto search transition-width duration-500 ease-in-out"
          :style="`width: ${isSeachGameFocus ? '75%' : '25%' };`"
          :placeholder="$t('Search All Games')"
          @keyup="searching"
        >
          <template #suffix>
            <!-- <font-awesome-icon icon="search" class="icon-search"/> -->
            <el-button
              @click.prevent="updateSearchResult"
              class="absolute top-0 rounded-l-none"
              style="padding: 0.5rem; height: 40px; border-radius: 0 8px 8px 0; right: -10px"
              type="primary"
              native-type="submit"
            >
              <font-awesome-icon icon="search" class="w-4 h-4 pr-1" />
            </el-button>
          </template>
        </el-input>
      </div>
    </div>
    <div v-loading="isLoading" class="p-4">
      <div class="inline-grid grid-cols-3 gap-2 w-full">
        <div
          v-for="init in gameReadyToRender"
          :key="init.GameId"
          class="relative w-full aspect-square border-[1px] border-[var(--border)] rounded-lg"
          :class="init.IsNewGame ? '' : init.IsPromotionGame ? '' : ''"
          @click="
            authenticated
              ? handleGameEntryOpenWindow(init, 550, 850)
              : toggleLoginRegisterDialog()
          "
        >
          <div class="absolute w-full">
            <div v-if="init.IsNewGame && !init.IsHotGame" class="w-1/2 aspect-[1/0]">
              <img
                class="w-full h-full object-contain pt-1 pl-1"
                :src="getAssetImage('assets/theme/common/icon/new_icon.svg')"
              />
            </div>
            <div v-if="init.IsHotGame" class="w-1/2 aspect-[1/0]">
              <img
                class="w-full h-full object-contain pt-1 pl-1"
                :src="getAssetImage('assets/theme/common/icon/hot_icon.svg')"
              />
            </div>
          </div>
          <IconFavorite
            :gameData="init"
            :checkIsFavourite="checkIsFavourite"
            :redirectToLogin="redirectToLogin"
            :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"
            :ForMobile="true"
            :toggle-dialog="true"/>
          <div class="w-full h-full">
            <img
              :src="isImageVersionExist(init.GameIconUrl)"
              class="aspect-[1/1] object-cover w-full h-full rounded-lg"
            />
          </div>
        </div>
        <div
          v-if="!gameCollection.length && !isLoading"
          class="col-span-3 grid place-content-center pt-24"
        >
          {{ $t("no_data") }}
        </div>
        <div ref="loadingMoreRef" class="w-full"></div>
      </div>
    </div>
    <el-backtop :right="30" :bottom="30">
      <div class="w-[35px] h-[35px] flex items-center justify-center">
        <font-awesome-icon icon="arrow-up" class="text-black" />
      </div>
    </el-backtop>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { computed, defineComponent, ref, watch } from "vue";
import {
  handleGameEntryOpenWindow,
  useGameEntryComponent,
  useAddToFavorite,
} from "@/composables/useTheme";
import commonHelper from "@/utils/commonHelper";
import { store } from "@/store";
import { IGameBsi } from "@/models/bsiGameList";
import textHelper from "~~/utils/formatHelpers/textFormatHelper";

export default defineComponent({
  name: "MGameEntryComponent",
  setup() {
    const { getAssetImage, toggleLoginRegisterDialog } = commonHelper;
    const providerModel = ref<string>();
    const preProviderModel = ref<string>();
    const {
      isLoading,
      headerTab,
      gameTypes,
      providers,
      initialGameEntry,
      searchedGame,
      tabInitial,
      subTabInitial,
      authenticated,
      handleSearchGame,
      handleSelectedTabOption,
      updateSearchResult,
      gameCollection,
    } = useGameEntryComponent();
    const {
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
    } = useAddToFavorite();
    const isScrollOver = ref(true);
    const marginTopInitialGameEntry = ref(0);
    const searchModel = ref(searchedGame.value);
    const onInputSearch = (val: string) => {
      searchedGame.value = val;
    };
    let timeout: any = null;
    const searching = (e: any) => {
      clearTimeout(timeout);
      if (e.target.value) {
        preProviderModel.value = providerModel.value;
        providerModel.value = "";
      } else {
        providerModel.value = preProviderModel.value;
      }
      timeout = setTimeout(() => {
        searchedGame.value = e.target.value;
        handleSearchGame();
      }, 800);
    };
    const onGameTabClicked = (segment: string, selected?: string) => {
      searchModel.value = "";
      handleSelectedTabOption(segment, selected);
    };
    const gameReadyToRender = ref<Array<IGameBsi> | undefined>([]);
    const index = ref(0);
    const gameRender = computed(() => {
      const chunkSize = 24;
      const games = [];
      if (gameCollection.value !== undefined) {
        for (let i = 0; i < gameCollection.value.length; i += chunkSize) {
          const chunk: Array<IGameBsi> | undefined =
            gameCollection.value.slice(i, i + chunkSize);
          games.push(chunk);
        }
      }
      return games;
    });
    const gameRenderer = () => {
      gameRender.value[index.value].forEach((item) => {
        gameReadyToRender.value?.push(item);
      });
    };
    watch(gameRender, () => {
      gameReadyToRender.value = [];
      index.value = 0;
      if (gameRender.value.length) {
        gameRenderer();
      }
    });
    const gameLoading = () => {
      index.value += 1;
      if (index.value < gameRender.value.length) {
        gameRenderer();
      }
    };
    const isImageVersionExist = (imageURL: string): string => {
      if (_.includes(imageURL, "?v=")) {
        return imageURL;
      }
      return `${imageURL}?v=${store.state.imageVersion}`;
    };
    const { convertString } = textHelper;
    const getProviderLogo = (providerName: string): string => {
      try {
        const fileName = `provider_logo_${convertString(providerName, true)}.png`;
        return getAssetImage(
          `assets/theme/bk8/desktop/logos/providers/${fileName}`
        );
      } catch (error) {
        return "";
      }
    };
    const isSeachGameFocus = ref(false);
    const { themeColor } = themePropertyHelper;

    const loadingMoreRef = ref();
    let loadMoreTimeout: NodeJS.Timeout;
    const observer = new IntersectionObserver(
      (entries) => {
        entries.forEach((entry) => {
          if (entry.isIntersecting) {
            clearTimeout(loadMoreTimeout);
            loadMoreTimeout = setTimeout(() => {
              gameLoading();
            }, 100);
          }
        });
      },
      {
        root: null,
        threshold: 0.5,
      }
    );

    watch(
      loadingMoreRef,
      () => {
        if (loadingMoreRef.value) {
          observer.observe(loadingMoreRef.value);
        }
      },
      {
        immediate: true,
      }
    );
    return {
      isLoading,
      headerTab,
      gameTypes,
      providers,
      initialGameEntry,
      tabInitial,
      providerModel,
      subTabInitial,
      authenticated,
      handleSelectedTabOption,
      handleGameEntryOpenWindow,
      commonHelper,
      isScrollOver,
      marginTopInitialGameEntry,
      getAssetImage,
      searchModel,
      searching,
      gameLoading,
      gameReadyToRender,
      isImageVersionExist,
      getProviderLogo,
      isSeachGameFocus,
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
      toggleLoginRegisterDialog,
      onGameTabClicked,
      onInputSearch,
      updateSearchResult,
      gameCollection,
      themeColor,
      loadingMoreRef,
    };
  },
});
</script>
<style lang="postcss" scoped>
:deep(.el-input--default.flex-auto > input.el-input__inner) {
  width: 100%;
}
:deep(.el-input .el-input__inner) {
  height: 40px !important;
  border-radius: 8px;
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
  padding-right: 37px;
}
:deep(.el-select .el-input__inner) {
  width: 100%;
  border-radius: 8px;
}
.before__content {
  @apply before:absolute before:top-0 before:px-[7px] before:py-[3px] before:rounded-tl-lg before:rounded-br-lg before:text-white  rounded-lg;
}
.before__new__content {
  @apply before:content-['NEW'] before:bg-[#31c46e];
}
.before__promo__content {
  @apply before:content-['PROMOTION'] before:bg-[#e63964];
}
.icon-custom-position {
  object-position: 50% -1px;
}
.selected-icon-custom-position {
  object-position: 50% -21px;
}
.el-select-dropdown__item.selected {
  color: var(--hint);
  border: none;
}
.bg-1 {
  background-color: rgb(5, 7, 30);
}
.bg-2 {
  background-color: rgb(31, 33, 65);
}
.border-selected {
  border-bottom: 2px solid var(--hint);
}
.selected-icon {
  display: block;
}
:deep(.el-input__inner) {
  font-size: 12px;
  height: 40px !important;
}
:deep(.el-select .el-input__inner) {
  color: white;
}
:deep(.el-select .el-input__inner) {
  color: white;
}
.btn-selected {
  opacity: 1;
  border: 1px solid var(--primary) !important;
}
.opacity {
  opacity: 1;
}
.border {
  border: 1px solid var(--border);
}
.el-select-dropdown__item {
  padding-left: 8px;
}
:deep(.el-input--prefix .el-input__inner) {
  padding-left: 45px;
}
.icon-search {
  font-size: 24px;
}
</style>
<style>
[layout="black_flexible_mobile_1"] .el-carousel {
  z-index: 10;
}
[theme-color="bk8"] .bg-1 {
 background-color: white;
}
[theme-color="bk8"] .el-input__inner {
 background-color: var(--background1);
  color: var(--text) !important;
}
.search span.el-input__suffix {
  display: flex;
  right: 10px;
  align-items: center;
  color: var(--el-input-icon-color, var(--el-text-color-placeholder));
}
.dropdown-width {
  width: 82%;
  left: 40px !important;
}
.el-popper.is-pure.is-light.el-select__popper.dropdown-width {
  border: 1px solid var(--border) !important;
}
</style>
<style lang="scss" scoped>
.hideScrollbar::-webkit-scrollbar {
  display: none;
}
</style>
